package org.dromara.knowledge.service;

import com.baomidou.mybatisplus.extension.service.IService;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.knowledge.domain.KnowledgeRoleRelation;
import org.dromara.knowledge.domain.bo.KnowledgeRoleRelationBo;
import org.dromara.knowledge.domain.vo.KnowledgeRoleRelationVo;

import java.util.Collection;
import java.util.List;

/**
 * 知识库角色关系Service接口
 *
 * @author pengles
 */
public interface KnowledgeRoleRelationService extends IService<KnowledgeRoleRelation> {

    /**
     * 查询知识库角色关系
     */
    KnowledgeRoleRelationVo queryById(Long id);

    /**
     * 查询知识库角色关系列表
     */
    TableDataInfo<KnowledgeRoleRelationVo> queryPageList(KnowledgeRoleRelationBo bo, PageQuery pageQuery);

    /**
     * 查询知识库角色关系列表
     */
    List<KnowledgeRoleRelationVo> queryList(KnowledgeRoleRelationBo bo);

    /**
     * 新增知识库角色关系
     */
    Boolean insertByBo(KnowledgeRoleRelationBo bo);

    /**
     * 修改知识库角色关系
     */
    Boolean updateByBo(KnowledgeRoleRelationBo bo);

    /**
     * 校验并批量删除知识库角色关系
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 根据角色ID查询关系列表
     */
    List<KnowledgeRoleRelationVo> queryByRoleId(Long roleId);

    /**
     * 根据分组ID查询关系列表
     */
    List<KnowledgeRoleRelationVo> queryByGroupId(Long groupId);

    /**
     * 根据角色ID和分组ID查询关系
     */
    KnowledgeRoleRelationVo queryByRoleIdAndGroupId(Long roleId, Long groupId);

}